//+------------------------------------------------------------------+
//|                                        TrendlessOS Histogram.mq4 |
//|                                      Copyright  2010, LenIFCHIK |
//|      ,     |
//|     "     |
//|"                                                         |
//|    ,         |
//| ,         |
//|      .        |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, LenIFCHIK"

#property indicator_separate_window               //  
#property indicator_buffers 5                     //  
//----  
extern int SMAPeriod=7;                           //      
extern double OBLevel=0.0047;                     //  
extern double OSLevel=-0.00473;                   //  
extern string Note_for_Display_mode="1 - line, 2 - colored histogram";
extern int Display_mode=2;                        //   ( / ) 
//----  
#property  indicator_color1  Navy                 //   
#property  indicator_color2  DimGray              //   (-60;60)
#property  indicator_color3  Lime                 //   (-80;-60]||[60;80)
#property  indicator_color4  Blue                 //   (-100;-80]||[80;100)
#property  indicator_color5  Red                  //   (--;-100]||[100;++)
//----  
double     TrendlessOSBuffer[];                   //   
double     ExtBuffer1[];                          //   (-60;60)
double     ExtBuffer2[];                          //   (-80;-60]||[60;80)
double     ExtBuffer3[];                          //   (-100;-80]||[80;100)
double     ExtBuffer4[];                          //   (--;-100]||[100;++)
//+------------------------------------------------------------------+
//| .  init                                      |
//+------------------------------------------------------------------+
int init()
  {
   string short_name;
   double EightyOBlvl=0.8*OBLevel;                //  80% 
   double EightyOSlvl=0.8*OSLevel;                //  80% 
   double SixtyOBlvl=0.6*OBLevel;                 //  60% 
   double SixtyOSlvl=0.6*OSLevel;                 //  60% 
//----  
   switch(Display_mode)                                //     
     {
      case 1 :                                         // 
        SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,1);      //   (     )
        SetIndexStyle(1,DRAW_NONE);                    //   (-60;60)
        SetIndexStyle(2,DRAW_NONE);                    //   (-80;-60]||[60;80)
        SetIndexStyle(3,DRAW_NONE);                    //   (-100;-80]||[80;100)
        SetIndexStyle(4,DRAW_NONE);                    //   (--;-100]||[100;++)
        break;
      case 2 :                                         // 
        SetIndexStyle(0,DRAW_NONE);                    //   (     )
        SetIndexStyle(1,DRAW_HISTOGRAM,STYLE_SOLID,1); //   (-60;60)
        SetIndexStyle(2,DRAW_HISTOGRAM,STYLE_SOLID,2); //   (-80;-60]||[60;80)
        SetIndexStyle(3,DRAW_HISTOGRAM,STYLE_SOLID,2); //   (-100;-80]||[80;100)
        SetIndexStyle(4,DRAW_HISTOGRAM,STYLE_SOLID,2); //   (--;-100]||[100;++)
        break;
     default :
        Display_mode=2;                                //  -  
     }      
//----  ,     
   SetIndexDrawBegin(0,SMAPeriod);                
   SetIndexDrawBegin(1,SMAPeriod);                
   SetIndexDrawBegin(2,SMAPeriod);
   SetIndexDrawBegin(3,SMAPeriod);
   SetIndexDrawBegin(4,SMAPeriod);                
//----  
   SetIndexBuffer(0,TrendlessOSBuffer);           //   
   SetIndexBuffer(1,ExtBuffer1);                  //   (-60;60)
   SetIndexBuffer(2,ExtBuffer2);                  //   (-80;-60]||[60;80)
   SetIndexBuffer(3,ExtBuffer3);                  //   (-100;-80]||[80;100)
   SetIndexBuffer(4,ExtBuffer4);                  //   (--;-100]||[100;++)
//----      
   short_name="TrendlessOS Histogramm("+SMAPeriod+")";       //     SMA
   IndicatorShortName(short_name);
   SetIndexLabel(0,short_name); 
//----      
   SetLevelValue(1,OBLevel);                      // 100% 
   SetLevelValue(2,OSLevel);                      // 100% 
   SetLevelValue(3,EightyOBlvl);                  // 80% 
   SetLevelValue(4,EightyOSlvl);                  // 80% 
   SetLevelValue(5,SixtyOBlvl);                   // 60% 
   SetLevelValue(6,SixtyOSlvl);                   // 60% 
//----  
   SetLevelStyle(STYLE_DOT,1,Silver);             //       
//----  
   return(0);
  }
//+------------------------------------------------------------------+
//| TrendlessOS Histogram                                            |
//+------------------------------------------------------------------+
int start()
  {
   int    limit;
   int    counted_bars=IndicatorCounted();
   double current;
//----   
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
//----  
   for(int i=0; i<limit; i++)
      TrendlessOSBuffer[i]=Close[i]-iMA(NULL,0,SMAPeriod,0,MODE_SMA,PRICE_CLOSE,i); 
//----     2      2                                          
   for(i=limit-1; i>=0; i--)
     {
      current=TrendlessOSBuffer[i];
      if(current>0.6*OSLevel && current<0.6*OBLevel)       //      (-60%;60%)                 
        {
         ExtBuffer1[i]=current;                            //   ExtBuffer1[]                
         ExtBuffer2[i]=0.0;                                
         ExtBuffer3[i]=0.0; 
         ExtBuffer4[i]=0.0;                      
        }
      else                                                 //       (-60%;60%),                                        
        {
         if((current>0.8*OSLevel && current<=0.6*OSLevel) || (current>=0.6*OBLevel && current<0.8*OBLevel)) //     (-80%;-60%]  [60%;80%)                  
           {
            ExtBuffer1[i]=0.0;                
            ExtBuffer2[i]=current;                         //   ExtBuffer2[]
            ExtBuffer3[i]=0.0; 
            ExtBuffer4[i]=0.0;                      
           }        
         else                                              //        (-80%;-60%]||[60%;80%),    
           {
            if((current>OSLevel && current<=0.8*OSLevel) || (current>=0.8*OBLevel && current<OBLevel))  //     (-100%;-80%]  [80%;100%)                  
              {
               ExtBuffer1[i]=0.0;                
               ExtBuffer2[i]=0.0;
               ExtBuffer3[i]=current;                      //  ExtBuffer3[]
               ExtBuffer4[i]=0.0;                      
              }                
            else                                           //        (-100%;-80%]||[80%;100%),    
              {
               if(current<=OSLevel || current>=OBLevel)    //      (--;-100%]||[100%;++)                 
                 {
                  ExtBuffer1[i]=0.0;                
                  ExtBuffer2[i]=0.0;
                  ExtBuffer3[i]=0.0; 
                  ExtBuffer4[i]=current;                   //  ExtBuffer4[] 
                 } 
              }
           }
        }  
  }
//---- 
   return(0);
  }
//+------------------------------------------------------------------+

